# ukui-kwin-effects
![build](http://gitlab2.kylin.com/kylin-desktop/ukui-kwin-effects/-/tree/master)
Multitask view runs in Kylin system.

[Badges]

## Introduction
For diversified adaptation, Multitask view is divided into two versions: PC version and TM version.
[PC version]
	Multitask view provides a convenient and fast interactive interface, which can make it convenient for users to switch virtual desktop and find the desired window, so as to improve users' production efficiency and work efficiency.
[TM version]
	Multitask view is convenient for users to manage the opened windows and improve the sense of interactive experience through different dynamic effects. In the tablet mode, you can control the wake-up and closing of the window, which is the necessary path to close the application in the tablet mode.

### Features
Common features of multitask views:
	1. Load as a plugin of ukui-kwin;
	2. It is necessary to turn on the compositor;
[PC version]
	The following are the features of the multitask view in PC mode:
	1. Add the functions of creating, deleting, exchanging virtual desktop and managing window content in virtual desktop;
	2. The window is of equal height and slides up and down, and one line places the window with the greatest possibility;
	3. Support small window dragging to different virtual desktops;
	4. Dual screen mode adaptation;
[TM version]
	1. Display the contents of the window with equal height and width, and can only slide left and right;
	2. Add all clear function;
	3. Support sliding up, closing, arousing, closing, arousing and other dynamic effects;
	4. Adapt to different system modes and desktop states;
## Requirements 
Please use the version after 0430 for ukui panel and ukui kwin.

## Installation
Obtain the package (ukui-kwin-effects) of multitask view from the warehouse source and execute "sudo apt install ukui-kwin-effects". 
Please ensure that the installed version meets the installation conditions of the new version!!!!

## Usage
[Open operation mode]
	1. Slide from the bottom of the screen to bring up the multitask view;
	2. Click the second button on the left side of the taskbar to evoke the multitask view;
	3. Win + Tab shortcut key evokes multitask view;
[Close operation mode]
	1. When the multitask view is open, click ESC to close the multitask view;
	2. When the multitask view is open, click the blank space of the multitask view to close the multitask view;
	3. When the multitask view is open, use the shortcut key "menu + Tab" to close the multitask view;
	4. In PC mode only and multitask view is on, click virtual desktop to close multitask view;
	5. When the multitask view is open, click the thumbnail window to close the multitask view;
	6. Passively trigger to close the multitask view. When a new window is activated, the multitask view will be closed automatically;

## Development
The multitask view is divided into two parts: the view module is developed with QML language and the back end is developed with C++ language.
The view module is divided into PC mode and tablet mode.

The development and commissioning shall be carried out according to the following steps:
1.cd ukui-kwin-effects
2.mkdir build
3.cd build
4.cmake ..
5.sudo make install
6.ukui-kwin --replace &
## Debuglog 
The log is stored in the log of kwin. The viewing method is as follows:
1.cd .log (or cd .config/ukui-kwin/log)
2.tail -f ukui_kwin_0.log

## Changelog 
You can view the record of each change in the changelog in Debian directory.

## FAQ
1. The multitask view always shows no application window?
	Please ensure that the current version of kwin is installed correctly
2. Shortcut keys cannot evoke multitask view?
	If ukui window switch is already installed in the system, please execute the following steps first:
	sudo dpkg -P ukui-window-switch
	After that:
	sudo rm -rf .config/kglobalshortcutsrc
	Final execution:
	reboot
3. Does the multitask view provide a DBUS interface and how to use it?
	Please use d-feet
	In the session, find "org.ukui.kwin" -> "/multitaskview" -> org.ukui.kWin.MultitaskView->show()
	Please ensure that the installed versions of kwin and ukui panel support the new version of multitask


